<template>
  <div class="columns">
    <div class="column border-right">
      <h2 class="title is-2">Login</h2>

      <div class="notification is-danger" v-if="authError">{{ authError }}</div>

      <form @submit.prevent="authenticate">
        <div class="box">
          <label>
            Username:
            <br />
            <input class="input" type="text" v-model="form.name" />
          </label>

          <label>
            Password:
            <br />
            <input class="input" type="password" v-model="form.password" />
          </label>
        </div>

        <input class="button is-link" type="submit" value="Login" />
      </form>
    </div>
    <div class="column">
        <h2 class="title is-2">Real Login</h2>

      <div class="notification is-danger" v-if="authError">{{ authError }}</div>

      <form @submit.prevent="authenticateReal">
        <div class="box">
          <label>
            Username:
            <br />
            <input class="input" type="text" v-model="form.name" />
          </label>

          <label>
            Password:
            <br />
            <input class="input" type="password" v-model="form.password" />
          </label>
        </div>

        <input class="button is-link" type="submit" value="Login" />
      </form>
    </div>
  </div>
</template>

<script>
import { login, loginReal } from "../../helpers/auth";

export default {
  name: "login",
  data() {
    return {
      form: {
        name: "",
        password: ""
      },
      error: null
    };
  },
  methods: {
    authenticate() {
      this.$store.dispatch("login");
      login(this.$data.form)
        .then(res => {
          this.$store.commit("loginSuccess", res);
          this.$router.push({ path: "/entries" });
        })
        .catch(err => {
          this.$store.commit("loginFailed", { err });
        });
    },
    authenticateReal() {
      this.$store.dispatch("loginReal");

      loginReal(this.$data.form)
        .then(res => {
          this.$store.commit("loginSuccess", res);
          this.$router.push({ path: "/entries" });
        })
        .catch(err => {
          this.$store.commit("loginFailed", { err });
        });
    }
  },
  computed: {
    authError() {
      return this.$store.getters.authError;
    }
  }
};
</script>